/*
 * "hello world" program, version 2
 *
 * creates threads using static inner class.  this allows creating each
 *   thread with thread-specific information (myID here).
 *
 * environment variable NUM_THREADS specifies number of threads.
 */
package csci3366sample.hello;
import csci3366sample.ThreadUtility;

public class Hello2 {

    // somewhat ugly hack so all threads have access to this value
    private static int numThreads = 0;

    public static void main(String[] args) {

        /* get number of threads from environment variable */

        //int numThreads = 0;
        try {
            numThreads = ThreadUtility.getNumThreads();
        }
        catch (ThreadUtility.Exception e) {
            System.err.println(e.getMessage());
            System.exit(1);
        }

        /* create threads */

        Thread[] threads = new Thread[numThreads];

        for (int i = 0; i < numThreads; ++i) {
            threads[i] = new Thread(new Inner(i));
        }

        /* start them up */

        System.out.println("starting threads");

        for (int i = 0; i < numThreads; ++i) {
            threads[i].start();
        }

        /* wait for them to finish */

        for (int i = 0; i < numThreads; ++i) {
            try {
                threads[i].join();
            }
            catch (InterruptedException e) {
                System.err.println("this should not happen");
            }
        }

        System.out.println("threads all done");
    }

    /* inner class containing code for each thread to execute */

    private static class Inner implements Runnable {

        private int myID;

        public Inner(int myID) {
            this.myID = myID;
        }

        public void run() {
            System.out.println("hello from " + myID + " of " + numThreads);
        }

    }
}
